package com.streambase.sb.adapter.component.http.client;
/*
* Copyright  2019. TIBCO Software Inc.
* This file is subject to the license terms contained
* in the license file that is distributed with this file.
*/


import java.io.IOException;
import java.util.Map;
import java.util.Map.Entry;

import javax.ws.rs.client.ClientRequestContext;
import javax.ws.rs.client.ClientRequestFilter;

public class AddHeaderOnRequestFilter implements ClientRequestFilter {
    
    private Map<String, String> headers;
    
    public AddHeaderOnRequestFilter(Map<String, String> headers) {
        this.headers = headers;
    }
    
    @Override
    public void filter(ClientRequestContext requestContext) throws IOException {
        if (headers != null) {
            for (Entry<String, String> entry : headers.entrySet()) {
                requestContext.getHeaders().add(entry.getKey(), entry.getValue());
            }
        }
    }
}