package com.streambase.sb.adapter.component.http.client;
/*
* Copyright  2019. TIBCO Software Inc.
* This file is subject to the license terms contained
* in the license file that is distributed with this file.
*/


import java.beans.*;

import com.streambase.sb.adapter.component.http.client.HTTPClient.HTTPStreamType;
import com.streambase.sb.operator.Operator;
import com.streambase.sb.operator.parameter.*;

public class HTTPClientBeanInfo extends SBSimpleBeanInfo {
    public static final String HTTP_STREAM_TYPE_PARAMETER_NAME = "httpStreamType";
    public static final String HTTP_STREAM_TYPE_DISPLAY_NAME = "HTTP Stream Type";
    public static final String HTTP_STREAM_TYPE_DESC = "The type of http streaming.";
    
    public static final String URL_PARAMETER_NAME = "url";
    public static final String URL_DISPLAY_NAME = "URL";
    public static final String URL_DESC = "The initial URL to connect to, or leave blank to not connect on startup and use the control port to connect.";

    public static final String CONNECT_TIMEOUT_PARAMETER_NAME = "connectTimeoutSeconds";
    public static final String CONNECT_TIMEOUT_DISPLAY_NAME = "Connect Timeout Seconds";
    public static final String CONNECT_TIMEOUT_DESC = "The time in seconds to wait for the connection to estabish";
    
    public static final String READ_TIMEOUT_PARAMETER_NAME = "readTimeoutSeconds";
    public static final String READ_TIMEOUT_DISPLAY_NAME = "Read Timeout Seconds";
    public static final String READ_TIMEOUT_DESC = "The time in seconds to wait for a read operation to complete, set to 0 to wait for ever.";

    public static final String RECONNECT_TIMEOUT_PARAMETER_NAME = "reconnectTimeoutSeconds";
    public static final String RECONNECT_TIMEOUT_DISPLAY_NAME = "Reconnect Timeout Seconds";
    public static final String RECONNECT_TIMEOUT_DESC = "The time in seconds to wait for reconnect attempts when using server-sent events.";    
    
    public static final String HTTP_LOG_LEVEL_PARAMETER_NAME = "httpLogLevel";
    public static final String HTTP_LOG_LEVEL_DISPLAY_NAME = "HTTP Log Level";
    public static final String HTTP_LOG_LEVEL_DESC = "The HTTP log level used by the adapter";
    
    public static final String LOG_LEVEL_PARAMETER_NAME = "LogLevel";
    public static final String LOG_LEVEL_DISPLAY_NAME = "Log Level";
    public static final String LOG_LEVEL_DESC = "The log level used by the adapter. Operates independently of the top-level StreamBase log level value.";
    
    public SBPropertyDescriptor[] getPropertyDescriptorsChecked() throws IntrospectionException {
        SBPropertyDescriptor[] p = {
                new JavaEnumPropertyDescriptor<HTTPStreamType>(HTTP_STREAM_TYPE_PARAMETER_NAME, HTTPClient.class, HTTPStreamType.class).optional().displayName(HTTP_STREAM_TYPE_DISPLAY_NAME).description(HTTP_STREAM_TYPE_DESC),
                new SBPropertyDescriptor(URL_PARAMETER_NAME, HTTPClient.class).displayName(URL_DISPLAY_NAME).description(URL_DESC).optional(),
                new SBPropertyDescriptor(CONNECT_TIMEOUT_PARAMETER_NAME, HTTPClient.class).displayName(CONNECT_TIMEOUT_DISPLAY_NAME).description(CONNECT_TIMEOUT_DESC).optional(),
                new SBPropertyDescriptor(READ_TIMEOUT_PARAMETER_NAME, HTTPClient.class).displayName(READ_TIMEOUT_DISPLAY_NAME).description(READ_TIMEOUT_DESC).optional(),
                new SBPropertyDescriptor(RECONNECT_TIMEOUT_PARAMETER_NAME, HTTPClient.class).displayName(RECONNECT_TIMEOUT_DISPLAY_NAME).description(RECONNECT_TIMEOUT_DESC).optional(),
                new JavaEnumPropertyDescriptor<Operator.LogLevel>(LOG_LEVEL_PARAMETER_NAME, HTTPClient.class, Operator.LogLevel.class).optional().displayName(LOG_LEVEL_DISPLAY_NAME).description(LOG_LEVEL_DESC)
        };
        return p;
    }

}
